<script lang="ts">
	import type { PokemonItem } from '$lib/index';
	import { Table, tableMapperValues, type TableSource } from '@skeletonlabs/skeleton';
	import { createEventDispatcher } from 'svelte';

	const dispatch = createEventDispatcher();

	export let pokemon: PokemonItem[] | undefined;
	export let busy = false;

	$: pokemonCount = pokemon?.length;

	function updateTableSimple(): TableSource {
		if (pokemon) {
			return {
				// A list of heading labels.
				head: ['Name'],
				// The data visibly shown in your table body UI.
				body: tableMapperValues(pokemon, ['name']),
				meta: tableMapperValues(pokemon, ['name', 'url']),
				// Optional: A list of footer labels.
				foot: [`Total <code class="code">${pokemonCount}</code>`]
			};
		}
		return {
			// A list of heading labels.
			head: ['Name'],
			// The data visibly shown in your table body UI.
			body: tableMapperValues([], ['name']),
			meta: tableMapperValues([], ['name', 'url']),
			// Optional: A list of footer labels.
			foot: [`Total <code class="code">${pokemonCount}</code>`]
		};
	}

	function onSelected({ detail }: { detail: string[] }) {
		dispatch('pokemonSelected', detail[0]);
	}

	$: tableSimple = pokemon ? updateTableSimple() : undefined;
</script>

{#if tableSimple}
	<Table interactive={!busy} source={tableSimple} on:selected={onSelected} />
{/if}
